#ifndef DUNE_CONSTANTS_H
#define DUNE_CONSTANTS_H

#define MAPMAGIC 3358395
#define SAVEMAGIC 5342535

#define	NUM_SAVEGAMES 6
#define GAMESPEED_MAX 25
#define GAMESPEED_MIN 5
#define VOLUME_MAX 100
#define VOLUME_MIN 0

#define MESSAGE_BUFFER_SIZE 5
#define MAX_PLAYERS 6
#define MAX_CLIENTYS 5
#define TICK_INTERVAL 30
#define PORT 5029
#define BUTTON_CLICK_TIME 100
#define NUM_MULTIGAMES 20

#define MSG_ACCEPT 'a'
#define MSG_ATTACK 't'
#define MSG_BUILDCOMMAND 'b'
#define MSG_BUILDCOMPLETE 'p'
#define MSG_BUTTONHIT 'h'
#define MSG_CANCELCOMMAND 'n'
#define MSG_CONSISTANCY 'o'
#define MSG_CREATEOBJECT 'r'
#define MSG_DEVASTATE 'k'
#define MSG_DEVIATE 'v'
#define MSG_JOIN 'j'
#define MSG_MESSAGE 'm'
#define MSG_OBJECTCOMMAND 'c'
#define MSG_OBJECTDESTROY 'd'
#define MSG_PALACESPECIAL 'l'
#define MSG_PALACEENABLE 'u'
#define MSG_PLACESTRUCTURE 'g'
#define MSG_QUIT 'q'
#define MSG_SETATTACKMODE 'i'
#define MSG_STARPORTORDER 'e'
#define MSG_STARPORTCANCEL 'f'
#define MSG_START 's'

#define BUILDERBUTTONSHEIGHT 48
#define BUILDERBUTTONSMINX 51
#define BUILDERBUTTONSMAXX 115
#define BUILDERBUTTONSMINY 201
#define BUILDERBUTTONSMAXY 423
#define BUILDERBUTTONSSPACING 10

#define BUILDERBUTTONSUPDOWNMINX 39
#define BUILDERBUTTONSUPDOWNMAXX 118
#define BUILDERBUTTONSUPMINY 167
#define BUILDERBUTTONSUPMAXY 188
#define BUILDERBUTTONSDOWNMINY 435
#define BUILDERBUTTONSDOWNMAXY 456

#define MAX_LINE 256
#define MAX_MUSICFILES 1000
#define MAX_MSGLENGTH 30
#define MAX_NAMELENGTH 20
#define MAX_UNITSOUNDS 5
#define MAX_XSIZE 256
#define MAX_YSIZE 256
#define ROCKFILLER 1		//how many times random generator will try to remove sand "holes" for rock from the map
#define SPICEFILLER 1		//for spice
#define ROCKFIELDS 10		//how many fields it will randomly generate
#define SPICEFIELDS 10
#define BUILDRANGE 2
#define RANDOMSPICEMIN 300	//how much spice on each spice tile
#define RANDOMSPICEMAX 500
#define RANDOMTHICKSPICEMIN 200
#define RANDOMTHICKSPICEMAX 300
#define ROCKBITS 10			//how many of the single bits of rock
#define conv2char 2.0 * PI / 256
#define BLOCKSIZE 16		//size of tile pieces 16x16
#define GAMEBARWIDTH 144
#define NONE -1
#define RANDOM -2

#define DEVIATIONTIME 1000
#define HARVESTERMAXSPICE 700
#define HARVESTSPEED 0.20
#define HARVESTEREXTRACTSPEED 0.75
#define RANDOMHARVESTMOVE 300
#define HEAVILYDAMAGEDRATIO 0.3	//if health/maxHealth < this, when damaged will become heavily damage- smoke and shit
#define HEAVILYDAMAGEDSPEEDMULTIPLIER 0.666666666666
#define MAXBUILDLIST 100		//the max amount of items a builder can have in its to build list
#define BUILDTIMEMULTIPLIER 10	//more of this will make things build slower
#define RANDOMTURNTIMER 2000	//less of this makes units randomly turn more
#define CHECKTIME 10
#define NUMSELECTEDLISTS 9
#define NUM_INFANTRY_PER_CELL 5		//how many infantry can fit in a cell

#define LASTSANDFRAME 2	//is number spice output frames - 1

#define UNIT_REPAIRCOST 0.1
#define DEFAULT_GUARDRANGE 10 //0 - 10, how far unit will search for enemy when guarding
#define DEFAULT_STARTINGCREDITS 3000
#define DEFAULT_TURNSPEED 0.625
#define DEFAULT_TURRETTURNSPEED 0.625
#define DEFAULT_UNITFRAMETIME 5
#define DEFAULT_UNITVIEWRANGE 5
#define DEVIATION_TIME 10000

#define NUM_STRUCTUREFRAMES 1
#define BARRACKS_HITPOINTS 800
#define BARRACKS_POWERREQUIREMENT 20
#define BARRACKS_VIEWRANGE 4 
#define CONSTRUCTIONYARD_HITPOINTS 1500
#define CONSTRUCTIONYARD_VIEWRANGE 6
#define GUNTURRET_HITPOINTS 700
#define GUNTURRET_POWERREQUIREMENT 10
#define GUNTURRET_VIEWRANGE 5
#define GUNTURRET_WEAPONDAMAGE 100
#define GUNTURRET_WEAPONRANGE 5
#define HEAVYFACTORY_HITPOINTS 1000
#define HEAVYFACTORY_POWERREQUIREMENT 35
#define HEAVYFACTORY_VIEWRANGE 5
#define HIGHTECHFACTORY_HITPOINTS 1000
#define HIGHTECHFACTORY_POWERREQUIREMENT 35
#define HIGHTECHFACTORY_VIEWRANGE 5
#define IX_HITPOINTS 1000
#define IX_POWERREQUIREMENT 40
#define IX_VIEWRANGE 3
#define LIGHTFACTORY_HITPOINTS 1000
#define LIGHTFACTORY_POWERREQUIREMENT 20
#define LIGHTFACTORY_VIEWRANGE 5
#define PALACE_HITPOINTS 2000
#define PALACE_POWERREQUIREMENT 10
#define PALACE_VIEWRANGE 8
#define RADAR_HITPOINTS 1000
#define RADAR_POWERREQUIREMENT 30
#define RADAR_VIEWRANGE 8
#define REFINERY_CAPACITY 2000
#define REFINERY_HITPOINTS 1500
#define REFINERY_POWERREQUIREMENT 30
#define REFINERY_VIEWRANGE 6
#define REPAIRYARD_HITPOINTS 1000
#define REPAIRYARD_POWERREQUIREMENT 20
#define REPAIRYARD_VIEWRANGE 5
#define ROCKETTURRET_HITPOINTS 700
#define ROCKETTURRET_POWERREQUIREMENT 15
#define ROCKETTURRET_VIEWRANGE 7
#define ROCKETTURRET_WEAPONDAMAGE 100 
#define ROCKETTURRET_WEAPONRANGE 9
#define SILO_CAPACITY 1000
#define SILO_POWERREQUIREMENT 5
#define SILO_VIEWRANGE 3
#define SILO_HITPOINTS 750
#define STARPORT_HITPOINTS 2000
#define STARPORT_POWERREQUIREMENT 80
#define STARPORT_VIEWRANGE 6
#define TILE_VIEWRANGE 2
#define WALL_HITPOINTS 500
#define WALL_VIEWRANGE 2
#define WINDTRAP_HITPOINTS 1000
#define WINDTRAP_POWERSUPPLY 100
#define WINDTRAP_VIEWRANGE 3 
#define WOR_HITPOINTS 1500
#define WOR_POWERREQUIREMENT 20
#define WOR_VIEWRANGE 5

#define CARRYALL_HITPOINTS 100
#define CARRYALL_SPEED 3.0
#define CARRYALL_TURNSPEED 0.1250
#define CARRYALL_VIEWRANGE 8
#define CARRYALL_WEAPONRANGE 0
#define CARRYALL_WEAPONDAMAGE 0
#define DEVASTATOR_HITPOINTS 500
#define DEVASTATOR_SPEED 0.25
#define DEVASTATOR_VIEWRANGE 8
#define DEVASTATOR_WEAPONRANGE 7
#define DEVASTATOR_WEAPONDAMAGE 100
#define DEVIATOR_HITPOINTS 200
#define DEVIATOR_SPEED 0.5
#define DEVIATOR_VIEWRANGE 8
#define DEVIATOR_WEAPONRANGE 6
#define DEVIATOR_WEAPONDAMAGE 40
#define HARVESTER_HITPOINTS 400
#define HARVESTER_VIEWRANGE 5
#define HARVESTER_WEAPONRANGE 0
#define HARVESTER_WEAPONDAMAGE 0
#define INFANTRY_FRAMETIME 500
#define INFANTRY_HITPOINTS 100
#define INFANTRY_VIEWRANGE 4
#define INFANTRY_SPEED 0.4
#define INFANTRY_WEAPONRANGE 3
#define INFANTRY_WEAPONDAMAGE 5
#define LAUNCHER_HITPOINTS 200
#define LAUNCHER_SPEED 0.5
#define LAUNCHER_VIEWRANGE 8
#define LAUNCHER_WEAPONRANGE 10
#define LAUNCHER_WEAPONDAMAGE 70
#define MCV_HITPOINTS 400
#define MCV_VIEWRANGE 7
#define MCV_WEAPONRANGE 0
#define MCV_WEAPONDAMAGE 0
#define ORNITHOPTER_HITPOINTS 100
#define ORNITHOPTER_SPEED 3.0
#define ORNITHOPTER_TURNSPEED 0.1250
#define ORNITHOPTER_VIEWRANGE 8
#define ORNITHOPTER_WEAPONRANGE 5
#define ORNITHOPTER_WEAPONDAMAGE 30
#define QUAD_HITPOINTS 450
#define QUAD_VIEWRANGE 4
#define QUAD_WEAPONRANGE 3
#define QUAD_WEAPONDAMAGE 25
#define SANDWORM_HITPOINTS 3000
#define SANDWORM_SPEED 1.0
#define SANDWORM_VIEWRANGE 8
#define SANDWORM_WEAPONRANGE 0
#define SANDWORM_WEAPONDAMAGE 1000
#define SIEGETANK_HITPOINTS 450
#define SIEGETANK_SPEED 0.3
#define SIEGETANK_VIEWRANGE 8
#define SIEGETANK_WEAPONRANGE 6
#define SIEGETANK_WEAPONDAMAGE 70
#define SONICTANK_HITPOINTS 200
#define SONICTANK_SPEED 0.5
#define SONICTANK_VIEWRANGE 8
#define SONICTANK_WEAPONRANGE 7
#define SONICTANK_WEAPONDAMAGE 70
#define TROOPER_HITPOINTS 100
#define TROOPER_VIEWRANGE 4
#define TROOPER_SPEED 0.3
#define TROOPER_WEAPONRANGE 7
#define TROOPER_WEAPONDAMAGE 50
#define TANK_HITPOINTS 350
#define TANK_SPEED 0.5
#define TANK_VIEWRANGE 6
#define TANK_WEAPONRANGE 5
#define TANK_WEAPONDAMAGE 70
#define TRIKE_HITPOINTS 300
#define TRIKE_VIEWRANGE 4
#define TRIKE_WEAPONRANGE 3
#define TRIKE_WEAPONDAMAGE 20 

#define NUM_ANGLES 8
#define MAXANGLE 7
#define RIGHT 0
#define RIGHTUP 1
#define UP 2
#define LEFTUP 3
#define LEFT 4
#define LEFTDOWN 5
#define DOWN 6
#define RIGHTDOWN 7


typedef enum {SCOUT, STANDGROUND, DEFENSIVE, AGGRESSIVE} ATTACKTYPE;
typedef enum {NOTBLOCKED, COMBLOCKED, MOUNTAIN, INFANTRY} BLOCKEDTYPE;
typedef enum {EASY, MEDIUM, HARD/*, IMPOSSIBLE*/} DIFFICULTYTYPE;
typedef enum {GS_NONE, START, BEGUN, END} GAMESTATETYPE;
typedef enum {CUSTOM, MULTIPLAYER, ORIGINAL, RANDOMMAP, SKIRMISH} GAMETYPE;
typedef enum {ATREIDES, ORDOS, HARKONNEN, SARDAUKAR, FREMEN, MERCENERY} PLAYERHOUSE;
typedef enum {CLIENT, SERVER, SINGLE} PLAYERTYPE;


#endif // DUNE_CONSTANTS_H
